﻿namespace MefContrib.Models.Provider.Tests
{
    using System.Collections.Generic;
    using NUnit.Framework;

    [TestFixture]
    public class ExportDescriptionTests
    {
        [Test]
        public void ContractShouldStoreSetValue()
        {
            ExportDescription description =
                new ExportDescription { ContractName = "dummy value" };

            Assert.AreEqual(description.ContractName, "dummy value");
        }

        [Test]
        public void MemberNameShouldStoreSetValue()
        {
            ExportDescription description =
                new ExportDescription { MemberName = "dummy value" };

            Assert.AreEqual(description.MemberName, "dummy value");
        }

        [Test]
        public void MetadataShouldStoreSetValue()
        {
            Dictionary<string, object> metadata =
                new Dictionary<string, object>();

            ExportDescription description =
                new ExportDescription { Metadata = metadata };

            Assert.AreSame(description.Metadata, metadata);
        }
    }
}