﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace MefContrib.Models.Provider.Definitions.Configurable
{
    public class PartCatalogConfigurationPartCollection : ConfigurationElementCollection
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PartCatalogConfigurationPartCollection"/>
        /// </summary>
        public PartCatalogConfigurationPartCollection()
        {
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        protected override ConfigurationElement CreateNewElement()
        {
            return new PartCatalogConfigurationPart();
        }

        public override ConfigurationElementCollectionType CollectionType
        {
            get
            {
                return ConfigurationElementCollectionType.BasicMap;
            }
        }

        protected override string ElementName
        {
            get
            {
                return "part";
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="element"></param>
        /// <returns></returns>
        protected override object GetElementKey(ConfigurationElement element)
        {
            PartCatalogConfigurationPart part =
                element as PartCatalogConfigurationPart;

            if (part != null)
            {
                return part.Type;
            }

            throw new InvalidOperationException();
        }
    }
}
