using System;
using System.Diagnostics;
using System.Runtime.Serialization;

namespace MefContrib.Models.Provider.Validation
{
    public static class Assumes
    {
        [DebuggerStepThrough]
        public static T NotReachable<T>()
        {
            throw new CodeNotReachableException("Code path should never be reached!");
        }
    }

    public class CodeNotReachableException : Exception
    {
        public CodeNotReachableException()
        {
        }

        public CodeNotReachableException(string message) : base(message)
        {
        }

        public CodeNotReachableException(string message, Exception inner) : base(message, inner)
        {
        }
    }
}